type operator = Add | Sub | Mul | Shiftr | Shiftl

type expr =
    Lit of string
  | Bits of string (* binary string *)
  | AsnRoot of string * expr
  | AsnObj of string * string * expr
  | IdenRoot of string
  | IdenObj of string * string
  | Binop of expr * operator * expr
  | Exprseq of expr * expr


type objdecl =
	Objdeclseq of string * objdecl * objdecl
  | Objmap of string * objdecl
  | Indices of int
  |	Indseq of int * objdecl


type statement  =
    Binmap of string * objdecl
  | Expr of expr
  | Stmtseq of statement * statement
  | Print of string * string
  | Printvar of string
  | Ifthen of expr * expr * statement * statement
  | Repeat of statement * expr * expr 
















(*

| objdecl SEMI objdecl    			{ Objdeclseq($1,$3) }



| expr SEMI expr   				{ Seq($1, $3) }
| INPUT expr SEMI INPUT expr    { Seq($2, $5) }
| expr SEMI  	   				{ Expr($1) }
| INPUT expr SEMI  				{ Expr($2) }


  | Seq of expr * expr
  | Expr of expr
  | Binop of expr * operator * expr


| expr PLUS   expr 				{ Binop($1, Add, $3) }
| expr MINUS  expr 				{ Binop($1, Sub, $3) }
| expr TIMES  expr			 	{ Binop($1, Mul, $3) }
| expr DIVIDE expr 				{ Binop($1, Div, $3) }




type expr =
    Literal of int
  | Id of string
  | Binop of expr * op * expr
  | Assign of string * expr
  | Call of string * expr list
  | Noexpr

type stmt =
    Block of stmt list
  | Expr of expr
  | Return of expr
  | If of expr * stmt * stmt
  | For of expr * expr * expr * stmt
  | While of expr * stmt
*)
