%{ open Ast %}

%token PLUS MINUS TIMES SEMI ASSIGN INPUT EOF LP RP PERIOD BINMAP LCB RCB SHIFTR SHIFTL PRINT EQU IF THEN ELSE REPEAT UNTIL 
%token <int>  LITERAL IND VARIABLE 
%token <string> ID BITS DEC

%left SEMI
%right ASSIGN INPUT
%left PLUS MINUS
%left TIMES DIVIDE

%start statement
%type < Ast.statement> statement
%type < Ast.objdecl> objdecl
%type < Ast.expr> expr

%%

statement:
  BINMAP ID LCB objdecl RCB			{ Binmap ($2,$4) }
| expr								{ Expr ($1) }
| statement statement				{ Stmtseq ($1, $2) }
| PRINT ID ID SEMI					{ Print ($2,$3) }
| PRINT ID SEMI						{ Printvar ($2) }
| IF LP expr EQU expr RP THEN 
	LP statement RP ELSE
	LP statement RP 				{ Ifthen($3,$5,$9,$13) }
| REPEAT LP statement RP 
  UNTIL LP expr EQU expr RP			{ Repeat($3,$7,$9) } 


objdecl:
  ID ASSIGN objdecl SEMI			{ Objmap($1,$3) 	}
| ID ASSIGN objdecl SEMI objdecl    { Objdeclseq($1,$3,$5) }
| IND								{ Indices($1) 		}
| IND objdecl						{ Indseq($1,$2) 	}

expr:
|  BITS			   					{ Bits($1) }
| DEC								{ Lit($1) }
| ID ASSIGN expr SEMI   			{ AsnRoot($1,$3) } 
| ID PERIOD ID ASSIGN expr SEMI 	{ AsnObj($1,$3,$5) }
| ID								{ IdenRoot($1) }
| ID PERIOD ID	 					{ IdenObj($1,$3) }
| expr PLUS   expr 					{ Binop($1, Add, $3) }
| expr MINUS  expr 					{ Binop($1, Sub, $3) }
| expr TIMES  expr			 		{ Binop($1, Mul, $3) }
| expr SHIFTR  expr 				{ Binop($1, Shiftr, $3) }
| expr SHIFTL  expr			 		{ Binop($1, Shiftl, $3) }
| expr expr							{ Exprseq ($1,$2) }
