{ open Parser }

rule token = parse
  [' ' '\t' '\r' '\n'] { token lexbuf }
| '+' { PLUS }
| '-' { MINUS }
| '*' { TIMES }
| ">>" { SHIFTR }
| "<<" { SHIFTL }
| ":=" { ASSIGN }
| "=" { EQU }
| ';' { SEMI }
| '(' { LP }
| ')' { RP }
| '{' { LCB }
| '}' { RCB }
| '.' { PERIOD }
| ['0' - '9']+'d' as decimal { DEC (decimal) }
| ['0' - '1']+ as bits { BITS (bits) }
| ['a'-'z']['a'-'z' '0'-'9']+ as lxm { ID(lxm) }
| "PRINT" { PRINT }
| "INPUT" { INPUT }
| "REPEAT" { REPEAT }
| "UNTIL"  { UNTIL }
| "IF"		{ IF }
| "THEN"	{ THEN }
| "ELSE"	{ ELSE }
| "BINMAP" { BINMAP }

| '['['0'-'9']']' as ind 
	{ IND(int_of_char ind.[1] - 48) }
| '['['0'-'9']['0'-'9']']' as ind 
	{ IND((10*(int_of_char ind.[1] - 48))
			+((int_of_char ind.[2] - 48)) ) }
| '['['0'-'9']['0'-'9']['0'-'9']']' as ind 
	{ IND((100*(int_of_char ind.[1] - 48))
			+(10*(int_of_char ind.[2] - 48))
			+(int_of_char ind.[3] - 48) ) }
| '['['0'-'9']['0'-'9']['0'-'9']['0'-'9']']' as ind 
	{ IND((1000*(int_of_char ind.[1] - 48))
		  +(100*(int_of_char ind.[2] - 48))
		   +(10*(int_of_char ind.[3] - 48))
		    +((int_of_char ind.[4] - 48)) ) }
| '['['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']']' as ind 
	{ IND((10000*(int_of_char ind.[1] - 48))
		  +(1000*(int_of_char ind.[2] - 48))
		   +(100*(int_of_char ind.[3] - 48))
		    +(10*(int_of_char ind.[4] - 48))
			+((int_of_char ind.[5] - 48)) ) }
| '['['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']']' as ind 
	{ IND((100000*(int_of_char ind.[1] - 48))
		  +(10000*(int_of_char ind.[2] - 48))
		   +(1000*(int_of_char ind.[3] - 48))
		    +(100*(int_of_char ind.[4] - 48))
			+(10*(int_of_char ind.[5] - 48))
			+((int_of_char ind.[6] - 48)) ) }
| '['['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']']' as ind 
	{ IND((1000000*(int_of_char ind.[1] - 48))
		  +(100000*(int_of_char ind.[2] - 48))
		   +(10000*(int_of_char ind.[3] - 48))
		    +(1000*(int_of_char ind.[4] - 48))
			+(100*(int_of_char ind.[5] - 48))
			+(10*(int_of_char ind.[6] - 48))
			+((int_of_char ind.[7] - 48)) ) }
| '['['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']']' as ind 
	{ IND((10000000*(int_of_char ind.[1] - 48))
		  +(1000000*(int_of_char ind.[2] - 48))
		   +(100000*(int_of_char ind.[3] - 48))
		    +(10000*(int_of_char ind.[4] - 48))
			+(1000*(int_of_char ind.[5] - 48))
			+(100*(int_of_char ind.[6] - 48))
			+(10*(int_of_char ind.[7] - 48))
			+((int_of_char ind.[8] - 48)) ) }
| '['['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']']' as ind 
	{ IND((100000000*(int_of_char ind.[1] - 48))
		  +(10000000*(int_of_char ind.[2] - 48))
		   +(1000000*(int_of_char ind.[3] - 48))
		    +(100000*(int_of_char ind.[4] - 48))
			+(10000*(int_of_char ind.[5] - 48))
			+(1000*(int_of_char ind.[6] - 48))
			+(100*(int_of_char ind.[7] - 48))
			+(10*(int_of_char ind.[8] - 48))
			+((int_of_char ind.[9] - 48)) ) }
| '['['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']']' 
	as ind 
	{ IND( (1000000000*(int_of_char ind.[1] - 48))
		  +(100000000*(int_of_char ind.[2] - 48))
		  +(10000000*(int_of_char ind.[3] - 48))
		  +(1000000*(int_of_char ind.[4] - 48))
		  +(100000*(int_of_char ind.[5] - 48))
		  +(10000*(int_of_char ind.[6] - 48))
		  +(1000*(int_of_char ind.[7] - 48))
		  +(100*(int_of_char ind.[8] - 48))
		  +(10*(int_of_char ind.[9] - 48)) 
		  +((int_of_char ind.[10] - 48)) ) }
| '['['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']['0'-'9']']' 
	as ind 
	{ IND( (10000000000*(int_of_char ind.[1] - 48))
		  +(1000000000*(int_of_char ind.[2] - 48))
		  +(100000000*(int_of_char ind.[3] - 48))
		  +(10000000*(int_of_char ind.[4] - 48))
		  +(1000000*(int_of_char ind.[5] - 48))
		  +(100000*(int_of_char ind.[6] - 48))
		  +(10000*(int_of_char ind.[7] - 48))
		  +(1000*(int_of_char ind.[8] - 48))
		  +(100*(int_of_char ind.[9] - 48)) 
		  +(10*(int_of_char ind.[10] - 48))
		  +((int_of_char ind.[11] - 48)) ) }




	

| eof { EOF }
